/*
 *
 *  Copyright (C) 2007-2015 SimplyCore, LLC
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 *
 */

#include <linux/kernel.h>
#include <linux/init.h>
#include <linux/slab.h>
#include <linux/usb.h>
#include <linux/types.h>
#include <linux/fs.h>
#include <linux/cdev.h>
#include <linux/poll.h>
#include <linux/spinlock.h>
#include <linux/list.h>
#include <linux/version.h>
#include <linux/kref.h>
#include <linux/device.h>
#include <linux/compat.h>
#include <asm/uaccess.h>
#include <linux/vmalloc.h>
#include <linux/module.h>
#define lIlIllII			((0x2563+312-0x267b)*(0x1d1c+567-0x1b53)) 
#define KERNEL_GT(lIlIlI,lIIIlI,llIlIII)			(LINUX_VERSION_CODE > KERNEL_VERSION(\
(lIlIlI),(lIIIlI),(llIlIII)))
#define KERNEL_LT(lIlIlI,lIIIlI,llIlIII)			(LINUX_VERSION_CODE < KERNEL_VERSION(\
(lIlIlI),(lIIIlI),(llIlIII)))
#define KERNEL_EQ(lIlIlI,lIIIlI,llIlIII)			(LINUX_VERSION_CODE == KERNEL_VERSION\
((lIlIlI),(lIIIlI),(llIlIII)))
#define KERNEL_GT_EQ(lIlIlI,lIIIlI,llIlIII)			(LINUX_VERSION_CODE >= \
KERNEL_VERSION((lIlIlI),(lIIIlI),(llIlIII)))
#define KERNEL_LT_EQ(lIlIlI,lIIIlI,llIlIII)			(LINUX_VERSION_CODE <= \
KERNEL_VERSION((lIlIlI),(lIIIlI),(llIlIII)))
#if defined(RHEL_RELEASE_CODE) 
#define RHEL_RELEASE_GT(lIlIlI,lIIIlI) 		(RHEL_RELEASE_CODE > \
RHEL_RELEASE_VERSION((lIlIlI),(lIIIlI)))
#define RHEL_RELEASE_LT(lIlIlI,lIIIlI)		(RHEL_RELEASE_CODE < \
RHEL_RELEASE_VERSION((lIlIlI),(lIIIlI)))
#define RHEL_RELEASE_EQ(lIlIlI,lIIIlI)		(RHEL_RELEASE_CODE == \
RHEL_RELEASE_VERSION((lIlIlI),(lIIIlI)))
#define RHEL_RELEASE_GT_EQ(lIlIlI,lIIIlI)		(RHEL_RELEASE_CODE >= \
RHEL_RELEASE_VERSION((lIlIlI),(lIIIlI)))
#define RHEL_RELEASE_LT_EQ(lIlIlI,lIIIlI)		(RHEL_RELEASE_CODE <= \
RHEL_RELEASE_VERSION((lIlIlI),(lIIIlI)))
#else
#define RHEL_RELEASE_GT(lIlIlI,lIIIlI) 		(0xe36+4107-0x1e41)
#define RHEL_RELEASE_LT(lIlIlI,lIIIlI)		(0x1924+1235-0x1df7)
#define RHEL_RELEASE_EQ(lIlIlI,lIIIlI)		(0x1533+1078-0x1969)
#define RHEL_RELEASE_GT_EQ(lIlIlI,lIIIlI)		(0xac4+3691-0x192f)
#define RHEL_RELEASE_LT_EQ(lIlIlI,lIIIlI)		(0x675+880-0x9e5)
#endif
#include "../public/pubstt2.h"
#include "../public/apitypes.h"
#include "../public/pubuniprotocol.h"
#include "../public/interface.h"
#include "../public/public_devices.h"
#include "driver.h"
#include "fifo.h"
#include "usbdcdev.h"
#include "usb_device.h"
#include "vhci_device.h"
#include "minor_control.h"
#include "minor_device.h"
#include "minor_vhci.h"
#include "utils.h"
#include "urb_chain.h"
#include "sg.h"
#define llIlll(lllIlllI, lIlIlllI...) printk( KERN_DEBUG \
"\x75\x73\x62\x64\x20\x5b\x25\x30\x39\x75\x5d\x3a\x20" lllIlllI, \
jiffies_to_msecs(jiffies), ## lIlIlllI)
#ifdef _USBD_DEBUG_BUILD_
#define IIIll(lllIlllI, lIlIlllI...) printk( KERN_DEBUG \
"\x75\x73\x62\x64\x20\x5b\x25\x30\x39\x75\x5d\x3a\x20" lllIlllI, \
jiffies_to_msecs(jiffies), ## lIlIlllI)
#else
#define IIIll(lllIlllI, lIlIlllI...)
#endif
#if KERNEL_LT_EQ((0xf8+7456-0x1e16),(0x85d+5219-0x1cba),(0x8a4+4848-0x1b7d))
typedef unsigned long uintptr_t;
#endif
#if KERNEL_LT_EQ((0xbdb+4834-0x1ebb),(0x1249+3542-0x2019),(0x842+3858-0x1745))
#define atomic_xchg(IIlIlIIlI, new) (xchg(&((IIlIlIIlI)->counter), new))
#endif

